package uk.co.petertribble.jangle;

import snmp.SNMPOctetString;

/**
 * Emulate snmpwalk. Only does SNMPv1 to localhost, public.
 */
public class SnmpWalk {

    private static SnmpMibManager smm;

    /**
     * Walk the snmp tree.
     *
     * @param args command line arguments, ignored
     */
    public static void main(String args[]) {
	smm = SnmpMibManager.getInstance();
	try {
	    SnmpParams snp = new SnmpParams("localhost");
	    SnmpController sc = new SnmpController(snp);
	    SnmpObject sno = sc.getNext("1.3.6.1.2.1");
	    while (sno != null) {
		printout(sno);
		sno = sc.getNext(sno);
	    }
	} catch (Exception e) {
	    System.err.println("Oops!");
	}
    }

    static private void printout(SnmpObject sno) {
	String type = sno.getTypeString();
	String oid = smm.prettifyOID(sno.toString());
	if ("OctetString".equals(type)) {
	    System.out.println(oid + " = "
			+ type + ": " + sno.valueString());
	    System.out.println("  (hex: "
		+ ((SNMPOctetString)sno.getValue()).toHexString() + ")");
	} else {
	    System.out.println(oid + " = "
			+ type + ": " + sno.getValue());
	}
    }
}
